#include "testlib.h"
#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;
const int MAXN = 510000;
int a[MAXN];
int qx[MAXN];
int qy[MAXN];

void print(int n, int m) {
	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		if (i != 0)
			cout << " ";
		cout << a[i];
	}
	cout << "\n";
	for (int i = 0; i < m; ++i)
		cout << qx[i] << " " << qy[i] << "\n";
}


void gen_bl_incr(int n, int m, int maxh, int bl, int br) {
	vector<int> vv;
	for (int i = 0; i < n; ++i)
		vv.push_back(rnd.next(1, maxh));
	sort(vv.begin(), vv.end());
	int cnt = 0;
	while (cnt < n) {
		int l = bl;
		int r = min(n - cnt, br);
		l = min(l, r);
		int sz = rnd.next(l, r);
		reverse(vv.begin() + cnt, vv.begin() + cnt + sz);
		cnt += sz;
	}
	for (int i = 0; i < n; ++i)
		a[i] = vv[i];
	for (int i = 0; i < m; ++i) {
		int k = rnd.next(1, 2);
		qx[i] = rnd.next(1, n);
		if (k == 1) {
			int d = rnd.next(-2, 2);
			qy[i] = min(maxh, max(1, a[qx[i] - 1] + d));
		}
		else
			qy[i] = rnd.next(1, maxh);
	}
}

void gen_bl_decr(int n, int m, int maxh, int bl, int br) {
	gen_bl_incr(n, m, maxh, bl, br);
	reverse(a, a + n);
	for (int i = 0; i < m; ++i)
		qx[i] = n + 1 - qx[i];
}


int main(int argc, char **argv) {
	//Usage: type, n, m, maxh, bl, br, seed
	assert(argc == 8);
	registerGen(argc, argv, 1);
	int t = atoi(argv[1]);
	int n = atoi(argv[2]);
	int m = atoi(argv[3]);
	int maxh = atoi(argv[4]);
	int bl = atoi(argv[5]);
	int br = atoi(argv[6]);
	switch (t) {
		case 1:
			gen_bl_incr(n, m, maxh, bl, br);
			break;
		case 2:
			gen_bl_decr(n, m, maxh, bl, br);
			break;
		default:
			assert(0);
	}
	print(n, m);
	return 0;
}


