#include "testlib.h"
#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;
const int MAXN = 510000;
int a[MAXN];
int qx[MAXN];
int qy[MAXN];

void print(int n, int m) {
	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		if (i != 0)
			cout << " ";
		cout << a[i];
	}
	cout << "\n";
	for (int i = 0; i < m; ++i)
		cout << qx[i] << " " << qy[i] << "\n";
}



int main(int argc, char **argv) {
	//Usage: n, maxh, seed
	assert(argc == 4);
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int maxh = atoi(argv[2]);
	int m = n;

	vector<int> vv;
	if (maxh >= 2 * n) {
		for (int i = 0; i < n; ++i)
			vv.push_back(i * 2 + 1);
	}
	else {
		for (int i = 0; i < n; ++i)
			vv.push_back(i + 1);
	}
	shuffle(vv.begin(), vv.end());
	for (int i = 0; i < n; ++i)
		a[i] = vv[i];

	vector<pair<int, int> > vv2;
	for (int i = 0; i < n; ++i)
		vv2.push_back(make_pair(i + 1, min(maxh, a[i] + 1)));
	shuffle(vv2.begin(), vv2.end());
	for (int i = 0; i < n; ++i)
		qx[i] = vv2[i].first, qy[i] = vv2[i].second;

	print(n, m);
	return 0;
}


