#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXN = 510000;
const int MOD = 1000000007;

int n, m;
int a[MAXN];
pair<int, int> rmq[MAXN * 4];

vector<int> vv;
int ql[MAXN];
int qr[MAXN];
pair<int, int> gol[MAXN];
pair<int, int> gor[MAXN];
vector<pair<int, int> > go[MAXN];
int qx[MAXN];
int qy[MAXN];
int fl[MAXN];

pair<int, int> merge(pair<int, int> x, pair<int, int> y) {
	if (x.first < y.first)
		swap(x, y);
	if (x.first == y.first) {
		x.second += y.second;
		if (x.second >= MOD)
			x.second -= MOD;
	}
	return x;
}

void build(int v, int tl, int tr) {
	rmq[v] = make_pair(0, 0);
	if (tl + 1 == tr)
		return;
	int m = (tl + tr) >> 1;
	build(v * 2 + 1, tl, m);
	build(v * 2 + 2, m, tr);
}

void upd(int v, int tl, int tr, int x, pair<int, int> y) {
	rmq[v] = merge(rmq[v], y);
	if (tl + 1 == tr)
		return;
	int m = (tl + tr) >> 1;
	if (x < m)
		upd(v * 2 + 1, tl, m, x, y);
	else
		upd(v * 2 + 2, m, tr, x, y);
}

pair<int, int> get(int v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l)
		return make_pair(0, 0);
	if (l <= tl && tr <= r)
		return rmq[v];
	int m = (tl + tr) >> 1;
	return merge(get(v * 2 + 1, tl, m, l, r), get(v * 2 + 2, m, tr, l, r));
}


int main() {
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i), vv.push_back(a[i]);
	for (int i = 0; i < m; ++i)
		scanf("%d%d", qx + i, qy + i), --qx[i];
	sort(vv.begin(), vv.end());
	vv.resize(unique(vv.begin(), vv.end()) - vv.begin());
	for (int i = 0; i < n; ++i)
		a[i] = lower_bound(vv.begin(), vv.end(), a[i]) - vv.begin();
	for (int i = 0; i < m; ++i)
		go[qx[i]].push_back(make_pair(qy[i], i));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < (int)go[i].size(); ++j) {
			int x = go[i][j].first, y = go[i][j].second;
			int x2 = lower_bound(vv.begin(), vv.end(), x) - vv.begin();
			ql[y] = get(0, 0, n, 0, x2).first;
		}
		gol[i] = get(0, 0, n, 0, a[i]);
		++gol[i].first;
		if (gol[i].first == 1)
			gol[i].second = 1;
		upd(0, 0, n, a[i], gol[i]);
	}
	pair<int, int> mx = rmq[0];
	build(0, 0, n);
	for (int i = n - 1; i >= 0; --i) {
		for (int j = 0; j < (int)go[i].size(); ++j) {
			int x = go[i][j].first, y = go[i][j].second;
			int x2 = upper_bound(vv.begin(), vv.end(), x) - vv.begin();
			qr[y] = get(0, 0, n, x2, n).first;
		}
		gor[i] = get(0, 0, n, a[i], n);
		++gor[i].first;
		if (gor[i].first == 1)
			gor[i].second = 1;
		upd(0, 0, n, a[i], gor[i]);
	}

	for (int i = 0; i < n; ++i)
		if (gol[i].first + gor[i].first - 1 == mx.first && ((ll)gol[i].second * (ll)gor[i].second) % MOD == mx.second)
			fl[i] = 1;

	for (int i = 0; i < m; ++i) {
		int x = qx[i];
		int ans = mx.first - fl[x];
		ans = max(ans, ql[i] + qr[i] + 1);
		printf("%d\n", ans);
	}

	return 0;
}


