#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;

const int MOD = 1000000007;
const int MX = 1000010;
const int MAXN = 500010;

pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
	if (a.first == b.first) {
		a.second += b.second;
		//if (a.second >= MOD)
		//	a.second -= MOD;
		return a;
	}
	else
		return (a.first > b.first ? a : b);
}

int n, m;
pair<int, int> rmq[MX * 2 + 10];
int a[MAXN];
int pl[MAXN];
vector<pair<int, int> > go[MAXN];
pair<int, int> cntl[MAXN];
pair<int, int> cntr[MAXN];
int cnt[MAXN];

void build() {
	fill(rmq, rmq + MX * 2 + 10, make_pair(0, 0));
}

void upd(int x, pair<int, int> y) {
	x += MX - 1;
	for (; x > 0; x = (x - 1) >> 1)
		rmq[x] = merge(rmq[x], y);
	rmq[0] = merge(rmq[0], y);
}

pair<int, int> get(int l, int r) {
	l += MX - 1;
	r += MX - 1;
	pair<int, int> ans = make_pair(0, 0);
	while (l < r) {
		if (!(l & 1))
			ans = merge(ans, rmq[l]);
		l = l >> 1;
		if (!(r & 1))
			ans = merge(ans, rmq[r - 1]);
		r = (r - 1) >> 1;
	}
	return ans;
}

vector<int> cmpr;

int main() {
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i), cmpr.push_back(a[i]);
	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d%d", &x, &y);
		cmpr.push_back(y);
		--x;
		go[x].push_back(make_pair(y, i));
		pl[i] = x;
	}
	sort(cmpr.begin(), cmpr.end());
	cmpr.resize(unique(cmpr.begin(), cmpr.end()) - cmpr.begin());

	for (int i = 0; i < n; ++i)
		a[i] = lower_bound(cmpr.begin(), cmpr.end(), a[i]) - cmpr.begin() + 1;

	build();

	for (int i = 0; i < n; ++i) {
		pair<int, int> gg = get(0, a[i]);
		if (gg.first == 0)
			gg.second = 1;
		cntl[i] = gg;
		for (int j = 0; j < (int)go[i].size(); ++j) {
			go[i][j].first = lower_bound(cmpr.begin(), cmpr.end(), go[i][j].first) - cmpr.begin() + 1;
			cnt[go[i][j].second] += get(0, go[i][j].first).first;
		}
		++gg.first;
		upd(a[i], gg);
	}
	pair<int, int> lis = rmq[0];

	build();

	for (int i = n - 1; i >= 0; --i) {
		pair<int, int> gg = get(a[i] + 1, MX);
		if (gg.first == 0)
			gg.second = 1;
		cntr[i] = gg;
		for (int j = 0; j < (int)go[i].size(); ++j)
			cnt[go[i][j].second] += get(go[i][j].first + 1, MX).first;
		++gg.first;
		upd(a[i], gg);
	}

	for (int i = 0; i < m; ++i) {
		int ans = cnt[i] + 1;
		ans = max(ans, lis.first - 1);
		if (lis.first != cntl[pl[i]].first + 1 + cntr[pl[i]].first || lis.second != ((ll)cntl[pl[i]].second * (ll)cntr[pl[i]].second) % MOD)
			ans = max(ans, lis.first);
		printf("%d\n", ans);
	}
	
	return 0;
}


