#include "testlib.h"
#include <set>

const int MAX_PROD = 1000 * 1000;
const int MAX_VALUE = 1000 * 1000 * 1000;
const int MAX_N[] = {-1, 1000, 100, 100, 400, 400, -1, -1};
const int MAX_M[] = {-1,    1, 100, 100, 400, 400, -1, -1};
const bool VALUES_DISTINCT[] = {false, false, true, false, true, false, true, false};

int max_val(int group, const int arr[]) {
    return arr[group] == -1 ? MAX_PROD : arr[group];
}

int main(int argc, char **argv) {
    registerValidation(argc, argv);
    
    int group = atoi(validator.group().data());
    
    int n = inf.readInt(1, max_val(group, MAX_N), "n");
    inf.readSpace();
    int m = inf.readInt(1, max_val(group, MAX_M), "m");
    inf.readEoln();
    
    ensure((long long)n * (long long)m <= MAX_PROD);
    
    std::set<int> values;
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            int val = inf.readInt(1, MAX_VALUE);
            
            if (VALUES_DISTINCT[group]) {
                ensuref(values.find(val) == values.end(),
                        "value %d appeared twice", val);
                values.insert(val);
            }
            
            if (j != m - 1) {
                inf.readSpace();
            }
        }
        
        inf.readEoln();
    }
    
    inf.readEof();
    return 0;
}