#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

struct Vertex {
    int ans, size_in;
    char visited;
    vector<ll> edges;
    
    Vertex() : visited(0), size_in(0) {}
};

vector<ll> values;
vector<Vertex> verteces;

size_t ltoi(ll val) {
    return lower_bound(values.begin(), values.end(), val) - values.begin();
}

template <typename Iter>
void insert(Iter begin, Iter end) {
    sort(begin, end);
    for (Iter it = begin; it != end - 1; ++it) {
        Vertex &vertex = verteces[ltoi(*it)];
        size_t to = ltoi(*(it + 1));
        
        if (*it != *(it + 1)) {
            vertex.edges.push_back(to);
            ++verteces[to].size_in;
        }
    }
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    
    vector<vector<ll> > matrix(n, vector<ll>(m));
    values.resize(n * m);
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            scanf("%lld", &matrix[i][j]);
            values[i * m + j] = matrix[i][j];
        }
    }
    
    sort(values.begin(), values.end());
    values.erase(unique(values.begin(), values.end()), values.end());
    verteces.resize(values.size());
    
    vector<ll> row(m), column(n);
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            row[j] = matrix[i][j];
        }
        insert(row.begin(), row.end());
    }
    for (int j = 0; j != m; ++j) {
        for (int i = 0; i != n; ++i) {
            column[i] = matrix[i][j];
        }
        insert(column.begin(), column.end());
    }
    
    
    vector<ll> curr, next;
    
    for (size_t i = 0; i != verteces.size(); ++i) {
        if (!verteces[i].size_in) {
            curr.push_back(i);
        }
    }
    
    int level = 1;
    while (!curr.empty()) {
        while (!curr.empty()) {
            Vertex &vertex = verteces[curr.back()];
            curr.pop_back();
            
            vertex.ans = level;
            
            for (vector<ll>::const_iterator it = vertex.edges.begin(); it != vertex.edges.end(); ++it) {
                Vertex &to = verteces[*it];
                if (!(--to.size_in)) {
                    next.push_back(*it);
                }
            }
        }
        
        ++level;
        curr.swap(next);
    }
    
    //printf("%d\n", level - 1);
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            printf("%d ", verteces[ltoi(matrix[i][j])].ans);
        }
        printf("\n");
    }
    
    return 0;
}