#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

vector<int> num;

vector<vector<int> > graph_eq, graph_less;
vector<char> vis;
vector<int> in_size;

void eq_dfs(int v) {
    vis[v] = true;
    for (vector<int>::const_iterator it = graph_eq[v].begin(); it != graph_eq[v].end(); ++it) {
        if (!vis[*it]) {
            num[*it] = num[v];
            eq_dfs(*it);
        }
    }
}

template <class Iter>
void add_eq_dges(Iter begin, Iter end) {
    for (Iter it = begin; it != end - 1; ++it) {
        if (it->first == (it + 1)->first) {
            //graph_eq[it->second].push_back((it + 1)->second);
            graph_eq[(it + 1)->second].push_back(it->second);
        }
    }
}

template <class Iter>
void add_dges(Iter begin, Iter end) {
    for (Iter it = begin; it != end - 1; ++it) {
        if (it->first < (it + 1)->first) {
            graph_less[num[it->second]].push_back(num[(it + 1)->second]);
            ++in_size[num[(it + 1)->second]];
        }
    }
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    
    vector<vector<pair<int, int> > > matrix(n, vector<pair<int, int> >(m)), matrix_tr(m, vector<pair<int, int> >(n));
    graph_eq.resize(n * m);
    graph_less.resize(n * m);
    in_size.resize(n * m, 0);
    num.resize(n * m);
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            scanf("%d", &matrix[i][j].first);
            matrix[i][j].second = i * m + j;
            num[i * m + j] = i * m + j;
            matrix_tr[j][i] = matrix[i][j];
        }
    }
    
    for (int i = 0; i != n; ++i) {
        sort(matrix[i].begin(), matrix[i].end());
        add_eq_dges(matrix[i].begin(), matrix[i].end());
    }
    for (int j = 0; j != m; ++j) {
        sort(matrix_tr[j].begin(), matrix_tr[j].end());
        add_eq_dges(matrix_tr[j].begin(), matrix_tr[j].end());
    }
    
    vis.resize(n * m, false);
    for (int i = 0; i != n * m; ++i) {
        if (!vis[i]) {
            eq_dfs(i);
        }
    }
    
    for (int i = 0; i != n; ++i) {
        add_dges(matrix[i].begin(), matrix[i].end());
    }
    for (int j = 0; j != m; ++j) {
        add_dges(matrix_tr[j].begin(), matrix_tr[j].end());
    }
    
    vector<int> curr, next;
    for (int i = 0; i != n * m; ++i) {
        if (!in_size[i]) {
            curr.push_back(i);
        }
    }
    
    vector<int> ans(n * m);
    
    int level = 1;
    while (!curr.empty()) {
        while (!curr.empty()) {
            int v = curr.back();
            curr.pop_back();
            ans[v] = level;
            
            for (vector<int>::const_iterator it = graph_less[v].begin(); it != graph_less[v].end(); ++it) {
                --in_size[*it];
                if (!in_size[*it]) {
                    next.push_back(*it);
                }
            }
        }
        
        curr.swap(next);
        ++level;
    }
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            printf("%d ", ans[num[i * m + j]]);
        }
        printf("\n");
    }
    
    return 0;
}