#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

int const MAXN = 1000;

int n, m;

int matrix[MAXN][MAXN], matrix_tr[MAXN][MAXN], ans[MAXN][MAXN];
bool vis[MAXN * MAXN];
int in_size[MAXN * MAXN];
vector<int> comps[MAXN * MAXN];
int num[MAXN * MAXN];

void dfs(int v, int comp) {
    vis[v] = true;
    comps[comp].push_back(v);
    num[v] = comp;
    
    int x = v / m, y = v % m;
    
    for (int j = 0; j != m; ++j) {
        if (y != j && matrix[x][j] == matrix[x][y] && !vis[x * m + j]) {
            dfs(x * m + j, comp);
        } else if (matrix[x][j] < matrix[x][y]) {
            ++in_size[comp];
        }
    }
    for (int i = 0; i != n; ++i) {
        if (x != i && matrix_tr[y][i] == matrix_tr[y][x] && !vis[i * m + y]) {
            dfs(i * m + y, comp);
        } else if (matrix_tr[y][i] < matrix_tr[y][x]) {
            ++in_size[comp];
        }
    }
}

int main() {
    scanf("%d %d", &n, &m);
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            scanf("%d", &matrix[i][j]);
            matrix_tr[j][i] = matrix[i][j];
        }
    }
    
    int comp_cnt = 0;
    for (int i = 0; i != n * m; ++i) {
        if (!vis[i]) {
            dfs(i, comp_cnt++);
        }
    }
    
    vector<int> curr, next;
    for (int i = 0; i != comp_cnt; ++i) {
        if (!in_size[i]) {
            curr.push_back(i);
        }
    }
    
    int level = 1;
    while (!curr.empty()) {
        for (int i = 0; i != curr.size(); ++i) {
            int comp = curr[i];
            
            for (vector<int>::const_iterator it = comps[comp].begin(); it != comps[comp].end(); ++it) {
                int x = *it / m, y = *it % m;
                ans[x][y] = level;
                
                for (int j = 0; j != m; ++j) {
                    if (matrix[x][j] > matrix[x][y]) {
                        --in_size[num[x * m + j]];
                        if (!in_size[num[x * m + j]]) {
                            next.push_back(num[x * m + j]);
                        }
                    }
                }
                for (int i = 0; i != n; ++i) {
                    if (matrix_tr[y][i] > matrix_tr[y][x]) {
                        --in_size[num[i * m + y]];
                        if (!in_size[num[i * m + y]]) {
                            next.push_back(num[i * m + y]);
                        }
                    }
                }
            }
        }
        
        curr.swap(next);
        next.clear();
        ++level;
    }
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            printf("%d ", ans[i][j]);
        }
        printf("\n");
    }
    
    return 0;
}