#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

struct Vertex {
    int ans, size_in;
    char visited;
    set<ll> edges;
    
    Vertex() : visited(0), size_in(0) {}
};

map<ll, Vertex> verteces;

void make_edge(ll from, ll to) {
    Vertex &vertex = verteces[from];
    if (vertex.edges.find(to) == vertex.edges.end()) {
        vertex.edges.insert(to);
        ++verteces[to].size_in;
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    
    vector<vector<ll> > matrix(n, vector<ll>(m));
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            cin >> matrix[i][j];
            if (verteces.find(matrix[i][j]) == verteces.end()) {
                verteces[matrix[i][j]] = Vertex();
            }
        }
    }
    
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            for (int ii = 0; ii != n; ++ii) {
                if (ii != i && matrix[i][j] < matrix[ii][j]) {
                    make_edge(matrix[i][j], matrix[ii][j]);
                }
            }
            for (int jj = 0; jj != m; ++jj) {
                if (jj != j && matrix[i][j] < matrix[i][jj]) {
                    make_edge(matrix[i][j], matrix[i][jj]);
                }
            }
        }
    }
    
    vector<ll> curr, next;
    
    for (map<ll, Vertex>::const_iterator it = verteces.begin(); it != verteces.end(); ++it) {
        if (!it->second.size_in) {
            curr.push_back(it->first);
        }
    }
    
    int level = 1;
    while (!curr.empty()) {
        while (!curr.empty()) {
            Vertex &vertex = verteces[curr.back()];
            curr.pop_back();
            
            vertex.ans = level;
            
            for (set<ll>::const_iterator it = vertex.edges.begin(); it != vertex.edges.end(); ++it) {
                Vertex &to = verteces[*it];
                if (!(--to.size_in)) {
                    next.push_back(*it);
                }
            }
        }
        
        ++level;
        curr.swap(next);
    }
    
    //cout << level - 1 << '\n';
    for (int i = 0; i != n; ++i) {
        for (int j = 0; j != m; ++j) {
            cout << verteces[matrix[i][j]].ans << ' ';
        }
        cout << '\n';
    }
    
    return 0;
}