import java.io.*;
import java.math.*;
import java.util.*;

public class ra_n2log_java {

  BufferedReader br;
  PrintWriter out;
  StringTokenizer st;
  boolean eof;


  int a[];
  int p[];
  int up[];
  int rc[];
  int get(int x) {
    if (x == up[x]) return x;
    return up[x] = get(up[x]);
  }
  void merge(int x, int y) {
    x = get(x);
    y = get(y);
    up[y] = x;
  }

  void solve() throws IOException {
    int n = nextInt();
    int m = nextInt();
    int N = n * m;
    a = new int[N];
    p = new int[N];
    up = new int[N];
    rc = new int[N];
    Integer[] P = new Integer[N];
    for (int i = 0; i < N; i++) {
      a[i] = nextInt();
      P[i] = i;
      up[i] = i;
    }
    Arrays.sort(P, new Comparator<Integer>(){
      @Override
      public int compare(Integer x, Integer y) {
        return a[x] - a[y];
      }
    });
    for (int i = 0; i < N; i++) {
      p[i] = P[i];
    }
    int pr = -1;
    int lastx[] = new int[n];
    int lasty[] = new int[m];
    Arrays.fill(lastx, -1);
    Arrays.fill(lasty, -1);
    int mxr[] = new int[n];
    int mxc[] = new int[m];
    for (int it = 0; it < N; it++) {        
      if (it + 1 == N || a[p[it]] != a[p[it + 1]]) {
        for (int it2 = pr + 1; it2 <= it; it2++) {
          int i = p[it2] / m;
          int j = p[it2] % m;
          if (lastx[i] != -1 && a[lastx[i]] == a[p[it2]]) {
            merge(lastx[i], p[it2]);
          }
          if (lasty[j] != -1 && a[lasty[j]] == a[p[it2]]) {
            merge(lasty[j], p[it2]);
          }
          lastx[i] = p[it2];
          lasty[j] = p[it2];
        }
        for (int it2 = pr + 1; it2 <= it; it2++) {
          int i = p[it2] / m;
          int j = p[it2] % m;
          int val = Math.max(mxr[i], mxc[j]) + 1;
          if (rc[get(p[it2])] < val) {
            rc[get(p[it2])] = val;
          }
        }
        for (int it2 = pr + 1; it2 <= it; it2++) {
          int i = p[it2] / m;
          int j = p[it2] % m;
          int val = rc[get(p[it2])];
          if (mxr[i] < val) {
            mxr[i] = val;
          }
          if (mxc[j] < val) {
            mxc[j] = val;
          }
        }
        pr = it;
      }
    }
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        out.print(rc[get(i * m + j)] + " ");
      }    
      out.println();
    }
  }

  ra_n2log_java() throws IOException {
    br = new BufferedReader(new InputStreamReader(System.in));
    out = new PrintWriter(System.out);
    solve();
    out.close();
  }

  public static void main(String[] args) throws IOException {
    new ra_n2log_java();
  }

  String nextToken() {
    while (st == null || !st.hasMoreTokens()) {
      try {
        st = new StringTokenizer(br.readLine());
      } catch (Exception e) {
        eof = true;
        return null;
      }
    }
    return st.nextToken();
  }

  String nextString() {
    try {
      return br.readLine();
    } catch (IOException e) {
      eof = true;
      return null;
    }
  }

  int nextInt() throws IOException {
    return Integer.parseInt(nextToken());
  }

  long nextLong() throws IOException {
    return Long.parseLong(nextToken());
  }

  double nextDouble() throws IOException {
    return Double.parseDouble(nextToken());
  }
}