#include "testlib.h"
#include <cassert>
#include <functional>
using namespace std;

map<string, function<char**(int, char**)>> generators;

#define ADD_GENERATOR(name) \
char** gen_##name(int n, char* argv[]); \
int notused_##name = (generators[#name] = gen_##name, -42); \
char** gen_##name(int n, char* argv[])

ADD_GENERATOR(rand) {
    for (int i = 2; i <= n; i++) {
        printf("%d %d\n", i, rnd.next(1, i - 1));
    }
    return argv;
}

ADD_GENERATOR(chain) {
    for (int i = 2; i <= n; i++) {
        printf("%d %d\n", i - 1, i);
    }
    return argv;
}

ADD_GENERATOR(star) {
    for (int i = 2; i <= n; i++) {
        printf("%d %d\n", 1, i);
    }
    return argv;
}

char** gen(int n, char** argv) {
    auto it = generators.find(argv[0]);
    assert(it != generators.end());
    return it->second(n, argv + 1);
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    ++argv;
    int n = atoi(argv[0]);
    printf("%d\n", n);
    ++argv;
    argv = gen(n, argv);
    argv = gen(n, argv);
}


