#include "testlib.h"
using namespace std;

const int MAXN[6] = {10, 50, 50, 5000, 100000, 500000};
const int N = 500500;

int par[N];
int rnk[N];

int get(int x) {
    return (x == par[x]) ? x : (par[x] = get(par[x]));
}

void merge(int a, int b) {
    a = get(a);
    b = get(b);
    ensuref(a != b, "there is a cycle in the tree");
    if (rnk[a] > rnk[b])
        swap(a, b);
    if (rnk[a] == rnk[b])
        rnk[b]++;
    par[a] = b;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    int n = inf.readInt(2, MAXN[group], "n");
    inf.readEoln();
    vector<pair<int, int>> T[2];
    for (int tree = 0; tree < 2; tree++) {
        for (int i = 1; i <= n; i++)
            par[i] = i, rnk[i] = 0;
        for (int i = 0; i < n - 1; i++) {
            int a, b;
            a = inf.readInt(1, n, "a[" + vtos(i) + "]");
            inf.readSpace();
            b = inf.readInt(1, n, "b[" + vtos(i) + "]");
            inf.readEoln();
            if (a > b)
                swap(a, b);
            T[tree].emplace_back(a, b);
            merge(a, b);
        }
    }
    if (group == 1) {
        vector<pair<int, int>> tmp(n);
        sort(T[0].begin(), T[0].end());
        sort(T[1].begin(), T[1].end());
        int d = set_difference(T[0].begin(), T[0].end(), T[1].begin(), T[1].end(), tmp.begin()) - tmp.begin();
        if (d > 1) {
            quitf(_fail, "Trees should differ in 0 or 1 edge but they differ in %d edges", d);
        }
    }
    inf.readEof();
}
