#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>
#include <tuple>
using namespace std;

int n;

const int N = 500500;
vector<int> E[N];

bool visited[N];
int used[N];
int curver = 0;

int DFS(int x, int p = -1) {
    int cnt = 1;
    used[x] = curver;
    visited[x] = true;
    for (int y : E[x]) {
        if (y == p)
            continue;
        if (used[y] == curver)
            continue;
        cnt += DFS(y, x);
    }
    return cnt;
}

bool is_tree(vector<pair<int, int>> edges) {
    ++curver;
    for (int i = 1; i <= n; i++)
        E[i].clear(), visited[i] = false;
    for (auto ed : edges) {
        int a, b;
        tie(a, b) = ed;
        E[a].push_back(b);
        E[b].push_back(a);
    }
    int visited = DFS(1);
    return visited == n;
}


int main() {
    scanf("%d", &n);
    vector<pair<int, int> > current_edges;
    vector<pair<int, int> > result_edges;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        if (a > b)
            swap(a, b);
        current_edges.emplace_back(a, b);
    }
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        if (a > b)
            swap(a, b);
        result_edges.emplace_back(a, b);
    }
    vector<tuple<int, int, int, int>> ans;
    for (int i = 0; i < n - 1; i++) {
        if (find(result_edges.begin(), result_edges.end(), current_edges[i]) == result_edges.end()) {
            swap(current_edges[i], current_edges.back());
            pair<int, int> tmp = current_edges.back();
            current_edges.pop_back();
            assert(!is_tree(current_edges));
            bool found = false;
            for (int j = 0; j < n - 1; j++) {
                if (visited[result_edges[j].first] != visited[result_edges[j].second]) {
                    current_edges.push_back(result_edges[j]);
                    ans.emplace_back(tmp.first, tmp.second, result_edges[j].first, result_edges[j].second);
                    found = true;
                    break;
                }
            }
            assert(found);
            --i;
        }
    }
    printf("%d\n", (int)ans.size());
    for (auto oper : ans) {
        int a, b, c, d;
        tie(a, b, c, d) = oper;
        printf("%d %d %d %d\n", a, b, c, d);
    }
}
